#define PHYSFS_DEPRECATED

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <list>
#include <string>

#include <physfs.h>


std::list<std::string> physfsGetFileNamesInDirectory(const char* dir)
{
	std::list<std::string> filenames;
	char **rc = PHYSFS_enumerateFiles(dir);
	if ( *rc == NULL )
	{
		printf("[PhysFS]: Error: Failed to enumerate filenames in directory '%s'\n", dir);
		return filenames;
	}
	char **i;
	std::string file;
	for ( i = rc; *i != NULL; i++ )
	{
		file = *i;
		printf(" * We've got [%s].\n", file.c_str());
		filenames.push_back(file);
	}
	PHYSFS_freeList(rc);
	return filenames;
} 


int main(int argc, char **argv)
{
	
    printf("\n");

    if (!PHYSFS_init(argv[0]))
    {
        printf("PHYSFS_init() failed!\n  reason: %s.\n", PHYSFS_getLastError());
        return 1;
    } /* if */
	printf("PHYSFS_init() success!\n");
	
	
	if ( !PHYSFS_mount("PROGDIR:", NULL, 1) )
	{
		printf("[PhysFS]: unsuccessfully mounted base %s folder. Error code: %d", "PROGDIR:", PHYSFS_getLastErrorCode());
		return 1;
	} 	

	physfsGetFileNamesInDirectory("books"); 
	



	
	

    if (!PHYSFS_deinit())
        printf("PHYSFS_deinit() failed!\n  reason: %s.\n", PHYSFS_getLastError());
	printf("PHYSFS_deinit() success!\n");
		
		
	
}

