#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef MAX_PATH
#define MAX_PATH 4096
#endif

static void convertPath2Amiga(char* newpath)
{
    // let's parse using '/' as separator...
    char* p = newpath;
    int l;
    while((p=strchr(p, '/'))!=NULL) {
        l = strlen(p);
        if(p!=newpath && p[-1]==':') {
            // special case for "BLA:/something" => "BLA:something"
            memmove(p, p+1, l); // delete the "/"
        } else {
            char* p2=strchr(p+1, '/');
            if(p2) {
                char tmp[MAX_PATH] = {0};
                memcpy(tmp, p, (p2-p));
                if(strcmp(tmp, "/..")==0) {
                    // go up 1 folder
                    p2=p-1;
                    while(p2!=newpath && *p2!='/' && *p2!=':') --p2;
                    if(p2==newpath)// should error, but let's just ignore then
                        p2 = p;
                    memmove(p2+1, p+3, l-2);
                    p = p2;
                } else if(strcmp(tmp, "/.")==0) {
                    // stay here
                    memmove(p, p+2, l-1);
                } else if(strcmp(tmp, "/")==0) {
                    // double //, let's remove it
                    memmove(p, p+1, l+1);
                } else {
                    ++p;
                }
            } else ++p;
        }
    }
}

const char* Path2Amiga(const char * p)
{
    static char tmppath[MAX_PATH];  // it's a static, so don't use 2 Path2Amiga in the same function call!
    if(!p) return NULL;
    if(!p[0]) return p;
    if(strlen(p)>=MAX_PATH) return NULL;    // should warn...
    memset(tmppath, 0, sizeof(tmppath));
    strcpy(tmppath, p);
    convertPath2Amiga(tmppath);
    return tmppath;
}

int main(int argc, const char** argv)
{
    if(argc<2) {
        printf("Usage %s PATH\nTo see conversion from Unix style to Amiga\n", argv[0]);
        return 0;
    }
    for (int i=1; i<argc; ++i)
        printf("\"%s\" => \"%s\"\n", argv[i], Path2Amiga(argv[i]));
    return 0;
}
